----------------------------------------------------------
--                    Employees.ads                     --
----------------------------------------------------------

PACKAGE Employees IS

   SUBTYPE IDType     IS Positive RANGE 1111..9999;
   TYPE    Employee   IS PRIVATE;

   FUNCTION  GetId      (E : Employee)    RETURN IdType;
   FUNCTION  GetGross   (E : Employee)    RETURN Float;
   FUNCTION  GetTax     (E : Employee)    RETURN Float;
   FUNCTION  "<"        (L, R : Employee) RETURN Boolean;
   PROCEDURE ComputePay (E : IN OUT Employee; H : IN Float);

PRIVATE

   MaxName: CONSTANT Positive := 20;
   SUBTYPE NameType IS String(1..MaxName);

   TYPE    GenderType IS (Female, Male);

   TYPE TaxStep IS RECORD
      Step        : Float := 0.00;
      Rate        : Float := 0.0;
   END RECORD;

   MaxSteps: CONSTANT Positive := 4;

   TaxRates : CONSTANT ARRAY (1..MaxSteps) OF TaxStep := (
      (200.00, 0.05),
      (300.00, 0.10),
      (400.00, 0.15),
      (500.00, 0.20));

   DependentDeduction : CONSTANT Float := 100.00;

   TYPE Employee IS RECORD
      ID          : IDType := IDType'Last;
      Name        : NameType := (OTHERS => ' ');
      Gender      : GenderType := Female;
      NumDepend   : Natural := 0;
      PayRate     : Float := 0.00;
      Hours       : Float := 0.0;
      GrossPay    : Float := 0.00;
      Tax         : Float := 0.00;
   END RECORD;

END;