----------------------------------------------------------
--                 WeeklyPayroll.adb                    --
----------------------------------------------------------


with Ada.Text_Io; use Ada.Text_Io;
with Ada.Integer_Text_Io; use Ada.Integer_Text_Io;
with Ada.Float_Text_Io; use Ada.Float_Text_Io;
with Employees; use Employees;
with Employees.Io; use Employees.Io;
with Sort_Generic;

procedure WeeklyPayroll is

   EmployeeFile, HoursFile, PayFile, ErrorFile  : File_Type;

   MaxEmployees  : constant Integer := 20;
   type EmployeeArrayType is array (Positive range <>) of Employee;
   Employees     : EmployeeArrayType(1..MaxEmployees);    -- The array of employees
   NumEmployees  : Integer := 0;                          -- The number of employees read from the employee file.

   function GetEmployeeIndex (Id : IdType) return Natural is
      -- Search the array of employees inorder to find the position of
      -- an employee with the matching id. Return 0 if there is no
      -- such employee.
   begin

   end;

   procedure SortEmployees is new Sort_Generic (...);

begin
   Open (EmployeeFile, In_File, "employees.dat");
   Open (HoursFile...);
   Create (ErrorFile...);
   Create (PayFile...);
   -- Don't forget to close files as soon as they are no longer needed
    
   while not End_Of_File (EmployeeFile) loop
       
      Get(EmployeeFile, Employees(I));       
   end loop;
    
   while not End_Of_File (HoursFile) loop
      -- Read a line from the hours file and match it to an employee
   end loop;
       -- Print header for payroll report
   for I in 1 .. NumEmployees loop
      -- Print next employee line
   end loop;
   -- Print totals
end;